unit WLT;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, FileCtrl, DskIO;

type
  TForm2 = class(TForm)
    Drive: TDriveComboBox;
    Label1: TLabel;
    StartSector: TSpinEdit;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DriveChange(Sender: TObject);
  private
    FDiskIO: TDiskIO;
  public
    function WriteBuffer(var Buffer; BufSize: Integer): Boolean;
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

procedure TForm2.FormCreate(Sender: TObject);
begin
   FDiskIO := TDiskIO.Create;
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
   FDiskIO.Free;
end;

procedure TForm2.DriveChange(Sender: TObject);
var I: Integer;
begin
   FDiskIO.Drive := Drive.Drive;
   try
     I := StartSector.Value;
   except
     on Exception do I := 0;
   end;
   StartSector.Value := 0;
   StartSector.MaxValue := FDiskIO.LogicalSectors-1;
   if I >= FDiskIO.LogicalSectors then
      StartSector.Value := FDiskIO.LogicalSectors-1 else StartSector.Value := I;
end;

function TForm2.WriteBuffer(var Buffer; BufSize: Integer): Boolean;
var I: Integer;
    J: Integer;
begin
   Result := False;
   try
     I := StartSector.Value;
   except
     on Exception do Exit;
   end;
   J := BufSize div FDiskIO.BytesPerSector;
   Result := FDiskIO.WriteLogicalSector(I, J, Buffer, BufSize);
end;

end.
